;*******************************************************************
;*******************************************************************
;***                                        
;***	Example of use BlitzBullet 
;***	(Physics Bullet Library wrapper for Blitz3D) 
;***   
;***	(c) 2010-2011 Mirage-lab Team 
;***	www.tools.mirage-lab.com                       
;***                                                  
;*******************************************************************
;*******************************************************************

Include "..\include\BlitzBullet.bb"

Graphics3D 800, 600,32,2
AppTitle "BlitzBullet:  Static concave body"
SetBuffer(BackBuffer())
SetFont LoadFont("Blitz")
SeedRnd MilliSecs ()

btCreateWorld(0,"license_key")
btCreateDebugDraw()
btDebugDrawSetMode(0)
btWorldSetFixedTimeStep(1.0/60)

camera=CreateCamera()
AmbientLight 180,180,180
PositionEntity camera,0,120,-100
RotateEntity camera,25,0,0

light=CreateLight(2)
PositionEntity light,500,40,0
RotateEntity light,0,0,-100

texPlane=LoadTexture("..\media\cell.png")
ScaleTexture texPlane,20,20
plane=CreatePlane()
EntityTexture  plane,texPlane

btBodyCreatePlane(0,1,0)

meshTube=LoadMesh("..\media\spring.b3d")
concaveBody=btBodyCreateTrimesh(meshTube,0,1)
btBodySetPosition(concaveBody,0,20,0)
btBodySetEntity(concaveBody,meshTube)
btBodySetLinearDamping(concaveBody,0.8)

mesh=CreateSphere()
EntityColor mesh,20,20,220
ScaleEntity mesh,2,2,2
body=btBodyCreateSphere(2,10)
btBodySetPosition(body,9,120,4)
btBodyAttachEntity(body,mesh)

Global hide=0
Repeat	
	If KeyHit(2) btDebugDrawSetMode(0)
	If KeyHit(3) btDebugDrawSetMode(1)
	If KeyHit(4) btDebugDrawSetMode(2)
	If KeyHit(5) btDebugDrawSetMode(1+2)

	If KeyHit(57)
		mesh=CreateSphere()
		EntityColor mesh,20,20,220
		ScaleEntity mesh,2,2,2
		body=btBodyCreateSphere(2,10)
		btBodySetPosition(body,9,120,4)
		btBodyAttachEntity(body,mesh)
	EndIf

	time=MilliSecs()
	btSimulation(0.1,2)
	New_time=MilliSecs()-time
	
	If KeyHit(35) Then
		If hide=0
			HideEntity meshTube
			hide=1
		Else
			ShowEntity meshTube
			hide=0
		EndIf
	EndIf

	UpdateWorld
	RenderWorld()
	btDebugDrawWorld(camera)

	frames=frames+1  
   	If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 	Text 10,10,"FPS: "+fps1
	Text 10,30,"dll time: "+New_time

	Text 10,50,"1,2,3,4 - debug draw mode"
	Text 10,70,"H - hide/show tube"
	Text 10,90,"space - create sphere"

	Flip 1
	
Until KeyHit(1)

btDestroyWorld()
End
