;*******************************************************************
;*******************************************************************
;***                                        
;***	Example of use BlitzBullet 
;***	(Physics Bullet Library wrapper for Blitz3D) 
;***   
;***	(c) 2010-2011 Mirage-lab Team 
;***	www.tools.mirage-lab.com                       
;***                                                  
;*******************************************************************
;*******************************************************************

Include "..\include\BlitzBullet.bb"

Graphics3D 800, 600,32,2
AppTitle "BlitzBullet: Dynamic concave body"
SetBuffer(BackBuffer())
SetFont LoadFont("Blitz")
SeedRnd MilliSecs ()

btCreateWorld(0,"license_key")
btCreateDebugDraw()
btDebugDrawSetMode(0)
btWorldSetFixedTimeStep(1.0/60)

camera=CreateCamera()
AmbientLight 180,180,180
PositionEntity camera,0,100,-100
RotateEntity camera,25,0,0

light=CreateLight(1)
PositionEntity light,500,40,0
RotateEntity light,0,0,-100

texPlane=LoadTexture("..\media\cell.png")
ScaleTexture texPlane,20,20
plane=CreatePlane()
EntityTexture  plane,texPlane

btBodyCreatePlane(0,1,0)

CreateConcaveBody(0,50,40,0,0,0,2)
CreateConcaveBody(-2,140,40,0,180,0,2)

Global hide=0
Repeat	
	If KeyHit(2) btDebugDrawSetMode(0)
	If KeyHit(3) btDebugDrawSetMode(1)
	If KeyHit(4) btDebugDrawSetMode(2)
	If KeyHit(5) btDebugDrawSetMode(1+2)

	If KeyHit(57)
		CreateConcaveBody(Rnd(-50,50),Rnd(50,100),Rnd(-50,50),Rnd(-180,180),Rnd(-180,180),Rnd(-180,180),1)
	EndIf

	time=MilliSecs ()
	btSimulation(0.2,3)
	New_time=MilliSecs ()-time

	If KeyHit(35) Then HideShowMeshes()

	UpdateWorld
	RenderWorld()
	btDebugDrawWorld(camera)

	frames=frames+1  
   	If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 	Text 10,10,"FPS: "+fps1
	Text 10,30,"dll time: "+New_time

	Text 10,50,"1,2,3,4 - debug draw mode"
	Text 10,70,"H - hide/show meshes"
	Text 10,90,"Space - create a dynamic concave body"

	Flip 1
	
Until KeyHit(1)

btDestroyWorld()

End

Type phEntity
	Field mesh
	Field body
End Type

Function CreateConcaveBody%(x#, y#, z#, pitch#, yaw#, roll#, scale#)
	phEnt.phEntity = New phEntity
	phEnt\mesh=LoadMesh("..\media\stool.b3d")
	ScaleMesh phEnt\mesh,scale,scale,scale
	phEnt\body=btBodyCreateTrimesh(phEnt\mesh,Rnd(10,50),TRIMESH_CONCAVE)
	EntityColor phEnt\mesh,Rand(100,200),Rand(100,200),Rand(100,200)
	btBodySetPosition(phEnt\body,x,y,z)
	btBodySetRotation(phEnt\body,pitch, yaw, roll)
	btBodyAttachEntity(phEnt\body,phEnt\mesh)

	btBodySetMargin(phEnt\body,0.4)
	btBodySetAngularSleepingThreshold(phEnt\body,0.4)
	btBodySetLinearSleepingThreshold(phEnt\body,0.2)
	If hide=1
		HideEntity phEnt\mesh
	EndIf

	Return phEnt\body
End Function

Function HideShowMeshes()
	
	If hide=0 Then
		For phEnt.phEntity = Each phEntity
			HideEntity phEnt\mesh	
		Next
		hide=1
	Else
		For phEnt.phEntity = Each phEntity
			ShowEntity phEnt\mesh
		Next
		hide=0
	EndIf
	
End Function
