;*******************************************************************
;*******************************************************************
;***                                        
;***	Example of use BlitzBullet 
;***	(Physics Bullet Library wrapper for Blitz3D) 
;***   
;***	(c) 2010-2011 Mirage-lab Team 
;***	www.tools.mirage-lab.com                       
;***                                                  
;*******************************************************************
;*******************************************************************

Include "..\include\BlitzBullet.bb"

Graphics3D 800, 600,32,2
AppTitle "BlitzBullet: Car on raycast"
SetBuffer(BackBuffer())
SetFont LoadFont("Blitz")

Global Frames,LastCheck,FPS_
Global mx#,my#,msx#,msy#

btCreateWorld(0,"license_key")
btCreateDebugDraw()
btWorldSetGravity(0,-9.8,0)
btDebugDrawSetMode(0)

Global flagPosCamera=0
camera=CreateCamera()
CameraClsColor camera,102,102,102
CameraRange  camera,1,6000
CameraZoom camera,1.5
AmbientLight 210,200,180
PositionEntity camera,400,170,-260
RotateEntity camera,25,0,0

light=CreateLight()
PositionEntity light,0,100,-250
RotateEntity  light,50,0,0

Global ground=LoadMesh("..\media\track\track.b3d")
bodyGround=btBodyCreateTrimesh(ground,0,1)

Global meshCar=LoadMesh("..\media\car.b3d")
PositionEntity meshCar,0,10,0
texCar=LoadTexture("..\media\color4.jpg")
EntityTexture meshCar,texCar


;/////////////////////////////////////////////////////////////////////////
;/////// Create Body Car
bodyCar=btBodyCreateConvexHull(meshCar,200,1)
btBodySetPosition(bodyCar,0,100,0)

btBodyAttachEntity(bodyCar,meshCar)
btBodySetRotation(bodyCar,0,90,0)
btBodySetPosition(bodyCar,250,50,20)

pivotCar=CreatePivot(meshCar)
PositionEntity pivotCar,0,0,0
RotateEntity pivotCar,0,0,0

;/////////////////////////////////////////////////////////////////////////
;/////// Create Car
vehicle=btCreateVehicle(bodyCar)
btVehicleSetCoordinateSystem(vehicle,0,1,2)
btBodySetAngularDamping(bodyCar,0.05)
btBodySetLinearDamping(bodyCar,0.05)

;///////////////////////////////////////////////////////////////////////
;/////// Create Wheel Car
Global wheelMesh_fl=LoadMesh("..\media\wheel.b3d")
EntityColor wheelMesh_fl,140,140,140
ScaleEntity wheelMesh_fl,0.97,0.97,0.97
RotateMesh wheelMesh_fl,0,180,0
Global wheelMesh_fr=LoadMesh("..\media\wheel.b3d")
EntityColor wheelMesh_fr,140,140,140
ScaleEntity wheelMesh_fr,0.97,0.97,0.97

Global wheelMesh_bl=LoadMesh("..\media\wheel.b3d")
EntityColor wheelMesh_bl,140,140,140
ScaleEntity wheelMesh_bl,0.97,0.97,0.97
RotateMesh wheelMesh_bl,0,180,0
Global wheelMesh_br=LoadMesh("..\media\wheel.b3d")
EntityColor wheelMesh_br,140,140,140
ScaleEntity wheelMesh_br,0.97,0.97,0.97

wheelBody_fl=btVehicleAddWheel(vehicle,-24,-12,37)
btWheelSetDirection(wheelBody_fl,0,-1,0)
btWheelSetAxis(wheelBody_fl,-1,0,0)
btWheelSetFront(wheelBody_fl,1)

wheelBody_fr=btVehicleAddWheel(vehicle,24,-12,37)
btWheelSetDirection(wheelBody_fr,0,-1,0)
btWheelSetAxis(wheelBody_fr,-1,0,0)
btWheelSetFront(wheelBody_fr,1)

wheelBody_bl=btVehicleAddWheel(vehicle,-24,-12,-28)
btWheelSetDirection(wheelBody_bl,0,-1,0)
btWheelSetAxis(wheelBody_bl,-1,0,0)

wheelBody_br=btVehicleAddWheel(vehicle,24,-12,-28)
btWheelSetDirection(wheelBody_br,0,-1,0)
btWheelSetAxis(wheelBody_br,-1,0,0)

For i=0 To btVehicleGetNumWheel(vehicle)-1
	wheel=btVehicleGetWheel(vehicle,i)
	btWheelSetRadius(wheel,10.5)
	btWheelSetSuspensionRestLength(wheel,2.2)
	btWheelSetSuspensionStiffness(wheel,1.6)
	btWheelSetSuspensionDamping(wheel,0.02)
	btWheelSetSuspensionCompression(wheel,0.7)
	btWheelSetRollInFluence(wheel,0.19)
	btWheelSetFrictionSlip(wheel,1.6)
Next


hideWorldGeometry=0
Const maxMotor=1450
motor#=0
break=0
setBodyCarActive=0

Const maxSteeringRotate#=0.5
steeringRotate#=0
modeCamera=1

btSimulation(0.1,8)

Repeat
	
	msx#=MouseXSpeed()
	msy#=MouseYSpeed()
		
	Camera_Look(camera)
		
	If KeyHit(2) btDebugDrawSetMode(0)
	If KeyHit(3) btDebugDrawSetMode(1)
	If KeyHit(4) btDebugDrawSetMode(2)
	If KeyHit(5) btDebugDrawSetMode(1+2)

	If KeyHit(35)
		If hideWorldGeometry=0
			hideWorldGeometry=1
		Else
			If hideWorldGeometry=1
				hideWorldGeometry=0
			EndIf
		EndIf
	EndIf
		
	If KeyHit(47) 
		If modeCamera<1
			modeCamera=modeCamera+1
		Else
			modeCamera=0
		EndIf
	EndIf

	If KeyDown(9)
		btVehicleResetSuspension(vehicle)
	EndIf
			
	ActiveCamera(camera,pivotCar,meshCar,0.03,0.02,0.03,-200,100,0,modeCamera)

	If KeyDown(57)
		btWheelSetBreak(wheelBody_fl,15)
		btWheelSetBreak(wheelBody_fr,15)
		motor=0
	Else
		btWheelSetBreak(wheelBody_fl,0)
		btWheelSetBreak(wheelBody_fr,0)
		If KeyDown(200)
			setBodyCarActive=1
			If motor<-1
				motor=0
			Else
				If motor < maxMotor
					motor=motor+6
				EndIf
			EndIf
		Else
			If KeyDown(208)
				setBodyCarActive=1
				If motor>1
					motor=0
				Else
					If motor > -maxMotor
						motor=motor-4.5
					EndIf
				EndIf
			Else
				setBodyCarActive=0
				motor=0
			EndIf
		EndIf
	EndIf
		
	If setBodyCarActive=1 Then btBodySetSleep(bodyCar,True)


	tempMotor#=0
	If (btWheelIsContact(wheelBody_fl)=1 Or btWheelIsContact(wheelBody_fr)=1) And (btWheelIsContact(wheelBody_bl)=1 Or btWheelIsContact(wheelBody_br)=1)
		tempMotor=motor
	Else
		motor=motor*0.99
		tempMotor=0
	EndIf
		
	If btWheelIsContact(wheelBody_fl)=0
		btWheelSetRotation(wheelBody_fl,btWheelGetRotation(wheelBody_fl)+motor*0.001)
	EndIf
	
	If btWheelIsContact(wheelBody_fr)=0
		btWheelSetRotation(wheelBody_fr,btWheelGetRotation(wheelBody_fr)+motor*0.001)
	EndIf
		
	btWheelSetEngineForce(wheelBody_fl,tempMotor)
	btWheelSetEngineForce(wheelBody_fr,tempMotor)

	If KeyDown(205)
		If steeringRotate < maxSteeringRotate
			steeringRotate=steeringRotate+0.024
		EndIf
	Else
		If KeyDown(203)
			If steeringRotate > -maxSteeringRotate
				steeringRotate=steeringRotate-0.024
			EndIf
		Else
			If steeringRotate > 0.03
				steeringRotate=steeringRotate-0.04
			Else
				If steeringRotate < -0.02
					steeringRotate=steeringRotate+0.04
				EndIf
			EndIf
		EndIf
	EndIf

	btWheelSetSteering(wheelBody_fl,steeringRotate)
	btWheelSetSteering(wheelBody_fr,steeringRotate)

	body_fl=btWheelGetContactBody(wheelBody_fl)
	body_fr=btWheelGetContactBody(wheelBody_fr)	

	If body_fl<>0 Then
		If(btBodyIsStatic(body_fl)=0)
			vx#=btBodyGetForwardX(bodyCar)*(motor/-7)
			vy#=btBodyGetForwardY(bodyCar)*(motor/-7)
			vz#=btBodyGetForwardZ(bodyCar)*(motor/-7)
			btBodyApplyForce(body_fl,vx,vy,vz)		
		EndIf
	EndIf
		
	If body_fr<>0 Then
		If(btBodyIsStatic(body_fr)=0)
			vx#=btBodyGetForwardX(bodyCar)*(motor/-7)
			vy#=btBodyGetForwardY(bodyCar)*(motor/-7)
			vz#=btBodyGetForwardZ(bodyCar)*(motor/-7)
			btBodyApplyForce(body_fr,vx,vy,vz)	
		EndIf
	EndIf

	If KeyDown(28)
		btBodyApplyForce(bodyCar,0,2900,0)
	EndIf
			
	btSimulation(0.1,8)
		
	btWheelSetEntity(wheelBody_fl,wheelMesh_fl)
	btWheelSetEntity(wheelBody_fr,wheelMesh_fr)
	btWheelSetEntity(wheelBody_bl,wheelMesh_bl)
	btWheelSetEntity(wheelBody_br,wheelMesh_br)
		
	UpdateWorld
	
	RenderWorld()
	
	HideWorld()
	btDebugDrawWorld(camera)
	If hideWorldGeometry=0 Then
		ShowWorld()
	EndIf
	Frames=Frames+1  
   	If MilliSecs()-render_time=>1000  fps1=Frames : Frames=0 : render_time=MilliSecs()  
	Text 10,10,"FPS: "+fps1
	Text 10,30,"1,2,3,4 - debug draw mode"
	Text 10,50,"H - hide/show meshes"
	Text 10,70,"Arrows - control car"
	Text 10,90,"Enter - apply force on Y"
	Text 10,110,"V - camera view"
	Text 10,130,"W,A,S,D - move camera"
	
	Flip 1
Until KeyHit(1)
btDestroyWorld()
End


Function HideWorld()

	HideEntity wheelMesh_fl
	HideEntity wheelMesh_fr
	HideEntity wheelMesh_bl
	HideEntity wheelMesh_br
	HideEntity ground
	HideEntity meshCar
	For i=0 To numBodyBox
		;HideEntity aMeshBox(i)
	Next
	
End Function 

Function ShowWorld()

	ShowEntity wheelMesh_fl
	ShowEntity wheelMesh_fr
	ShowEntity wheelMesh_bl
	ShowEntity wheelMesh_br
	ShowEntity ground
	ShowEntity  meshCar
	For i=0 To numBodyBox
		;ShowEntity aMeshBox(i)
	Next
	
End Function 

Function GetFPS()
	Frames = Frames + 1
	
	If MilliSecs()>LastCheck+1000 Then
		LastCheck = MilliSecs()
		FPS_ = Frames
		Frames = 0
	EndIf
	Return FPS_	
End Function

Function Camera_Look(cam,speedx#=.5,speedy#=.5,dang=-89,upang=89)
	If KeyDown(17) Then 
		MoveEntity cam,0,0,2
	Else
		If KeyDown(31) Then MoveEntity cam,0,0,-2
	EndIf
	If KeyDown(30) Then 
		MoveEntity cam,-2,0,0	
	Else
		If KeyDown(32) Then MoveEntity cam,2,0,0
	EndIf	
	
	xrot#=EntityPitch(cam)
	yrot#=EntityYaw(cam)
	If(xrot#<upang)And(msy>0)Then xrot#=xrot#+speedx#*msy/10  
	If(xrot#>upang)And(msy>0)Then xrot#=upang	
	If(xrot#>dang)And(msy<0)Then xrot#=xrot#+speedx#*msy/10 
	If(xrot#<dang)And(msy<0)Then xrot#=dang		
	yrot=yrot-speedy#*msx/10 
	RotateEntity cam,xrot,yrot,0
End Function

Function ActiveCamera(cam,pivot_car,ent_car,cspeedX#,cspeedY#,cspeedZ#,dist#,hite#,xrot#,Modecamera)
	
	If KeyDown (30) Then 
		TurnEntity pivot_car,0,-1,0
	Else	
		If KeyDown (32) Then TurnEntity pivot_car,0,1,0
 	EndIf
	
	Select Modecamera	  	    
		Case 0
		    EntityParent cam,0
			PointEntity cam,pivot_car
			
			TFormPoint 0,hite,dist,pivot_car,0
			cx#=(TFormedX()-EntityX(cam))*(cspeedX#)
			cy#=(TFormedY()-EntityY(cam))*(cspeedY#)
			cz#=(TFormedZ()-EntityZ(cam))*(cspeedZ#)
			TranslateEntity cam,cx,cy,cz
			flagPosCamera=0
		Case 2		 
		    RotateEntity cam,0,0,0
			PositionEntity cam,0,35,15
			EntityParent cam,ent_car	
			flagPosCamera=0						
		Case 3
		    EntityParent cam,ent_car
			RotateEntity cam,0,0,0
			PositionEntity cam,-10,27,-4
			flagPosCamera=0	
		Case 4
			RotateEntity cam,0,0,0
			PositionEntity cam,-27,15,-2
			flagPosCamera=0	
		Case 1
			EntityParent cam,0
			If flagPosCamera=0
				PositionEntity cam,400,170,-260
				flagPosCamera=1
			EndIf
			PointEntity cam,ent_car	   	    	
	End Select 
	
	
End Function