;*******************************************************************
;*******************************************************************
;***                                        
;***	Example of use BlitzBullet 
;***	(Physics Bullet Library wrapper for Blitz3D) 
;***   
;***	(c) 2010-2011 Mirage-lab Team 
;***	www.tools.mirage-lab.com                       
;***                                                  
;*******************************************************************
;*******************************************************************

Include "..\include\BlitzBullet.bb"

Graphics3D 800, 600,32,2
AppTitle "BlitzBullet: Terrain"
SetBuffer(BackBuffer())
SetFont LoadFont("Blitz")

btCreateWorld(0,"license_key")
btCreateDebugDraw()
btDebugDrawSetMode(0)
btWorldSetFixedTimeStep(1.0/30)
btContactSetSolverIterations(2)

camera=CreateCamera()
AmbientLight 180,180,180
PositionEntity camera,150,150,-60
RotateEntity camera,40,0,0

light=CreateLight(2)
PositionEntity light,0,1500,-400

terrain=LoadTerrain( "..\media\Height_map.bmp" ) 
ScaleEntity terrain,5,50,5

grass_tex=LoadTexture( "..\media\grass.jpg" )
ScaleTexture grass_tex,20,20
EntityTexture terrain,grass_tex,0,1 

bodyTerratin=btbodyCreateTerrain(terrain,5,50,5)
btBodySetPosition(bodyTerratin,160,24,160)

For i=0 To 250
	phCreateSphere()
Next

Repeat

	If KeyHit(2) btDebugDrawSetMode(0)
	If KeyHit(3) btDebugDrawSetMode(1)
	If KeyHit(4) btDebugDrawSetMode(2)
	If KeyHit(5) btDebugDrawSetMode(1+2)
		
	UpdateWorld
	btSimulation(0.06,6)

	RenderWorld()
	btDebugDrawWorld(camera)
	Frames=Frames+1  
   	If MilliSecs()-render_time=>1000  fps1=Frames : Frames=0 : render_time=MilliSecs()
	Text 10,10,"FPS: "+fps1
	Text 10,30,"1,2,3,4 - debug draw mode"

	Flip 1
	
Until KeyHit(1)
btDestroyWorld()
End

Type phEntity
	Field mesh
	Field body
End Type

Function phCreateSphere()
	
	phEnt.phEntity = New phEntity
	radius#=Rnd(4,6)
	phEnt\mesh=CreateSphere()
	EntityShininess phEnt\mesh,0.5
	ScaleEntity phEnt\mesh,radius,radius,radius
	phEnt\body=btBodyCreateSphere(radius,Rnd(5,10))
	EntityColor phEnt\mesh,Rand(100,200),Rand(100,200),Rand(100,200)		
	
	btBodySetPosition(phEnt\body,Rnd(-0,300),Rnd(50,1500),Rnd(0,300))
	btBodySetRotation(phEnt\body,Rnd(-180,180),Rnd(-180,180),Rnd(-180,180))
	btBodyAttachEntity(phEnt\body,phEnt\mesh)
	
	btBodySetAngularSleepingThreshold(phEnt\body,1)
	btBodySetLinearSleepingThreshold(phEnt\body,1)
End Function