;*******************************************************************
;*******************************************************************
;***                                        
;***	Example of use BlitzBullet 
;***	(Physics Bullet Library wrapper for Blitz3D) 
;***   
;***	(c) 2010-2011 Mirage-lab Team 
;***	www.tools.mirage-lab.com                       
;***                                                  
;*******************************************************************
;*******************************************************************

Include "..\include\BlitzBullet.bb"

Graphics3D 800, 600,32,2
AppTitle "BlitzBullet: Materials"
SetBuffer(BackBuffer())
SetFont LoadFont("Blitz")
SeedRnd MilliSecs()

btCreateWorld(0,"license_key")
btCreateDebugDraw()
btDebugDrawSetMode(0)

camera=CreateCamera()
AmbientLight 180,180,180
PositionEntity camera,-10,80,-120
RotateEntity camera,20,0,0

light=CreateLight(1)
PositionEntity light,0,500,-200

plane=CreatePlane()
texPlane=LoadTexture( "..\media\cell.png" )
ScaleTexture texPlane,25,25
EntityTexture plane,texPlane,0,1 


bodyPlane=btBodyCreatePlane(0,1,0)
btBodySetRestitution(bodyPlane,0.5)

meshPanel=CreateCube()
ScaleEntity meshPanel,40,2,100
bodyPanel=btBodyCreateBox(40,2,100,0)
btBodyAttachEntity(bodyPanel,meshPanel)
btBodySetRotation(bodyPanel,0,-25,-20)
btBodySetPosition(bodyPanel,-30,25,40)
btBodySetRestitution(bodyPanel,0.5)


phBox1=phCreateCube(Rand(150,200),Rand(70,100),Rand(70,100))
btBodySetPosition(phBox1,-80,50,-30)
btBodySetFriction(phBox1,0.96)

phBox2=phCreateCube(Rand(150,200),Rand(70,100),Rand(70,100))
btBodySetPosition(phBox2,-70,50,-10)
btBodySetFriction(phBox2,0.7)

phBox3=phCreateCube(Rand(150,200),Rand(70,100),Rand(70,100))
btBodySetPosition(phBox3,-60,50,10)
btBodySetFriction(phBox3,0.0)

phBox4=phCreateCube(Rand(70,100),Rand(150,200),Rand(70,100))
btBodySetPosition(phBox4,-50,50,30)
btBodySetFriction(phBox4,0.9)
btBodySetRestitution(phBox4,1.4)

phBox5=phCreateCube(Rand(70,100),Rand(150,200),Rand(70,100))
btBodySetPosition(phBox5,-40,50,50)
btBodySetFriction(phBox5,1)
btBodySetRestitution(phBox5,1.6)

phBox6=phCreateCube(Rand(150,200),Rand(70,100),Rand(150,200))
btBodySetPosition(phBox6,-30,50,70)
btBodySetAnisotropicFriction(phBox6,10,10,50)

phBox7=phCreateCube(Rand(150,200),Rand(70,100),Rand(150,200))
btBodySetPosition(phBox7,-20,50,90)
btBodySetAnisotropicFriction(phBox7,50,10,10)

phResetAllEntity()

flag_activate=0

Repeat

	If KeyHit(2) btDebugDrawSetMode(0)
	If KeyHit(3) btDebugDrawSetMode(1)
	If KeyHit(4) btDebugDrawSetMode(2)
	If KeyHit(5) btDebugDrawSetMode(1+2)
		
	If KeyHit(57)
		btBodySetPosition(phBox1,-80,50,-30)
		btBodySetPosition(phBox2,-70,50,-10)
		btBodySetPosition(phBox3,-60,50,10)
		btBodySetPosition(phBox4,-50,50,30)	
		btBodySetPosition(phBox5,-40,50,50)
		btBodySetPosition(phBox6,-30,50,70)
		btBodySetPosition(phBox7,-20,50,90)
		
		phResetAllEntity()
	EndIf

	btSimulation(0.04,7)
	UpdateWorld()

	RenderWorld()
	btDebugDrawWorld(camera)
	Frames=Frames+1
	
   	If MilliSecs()-render_time=>1000  fps1=Frames : Frames=0 : render_time=MilliSecs()
	Text 10,10,"FPS: "+fps1
	Text 10,30,"1,2,3,4 - debug draw mode"
	Text 10,50,"Space - reset scene"

	Flip 1
	
Until KeyHit(1)
btDestroyWorld()
End

Type phEntity
	Field mesh
	Field body
End Type

Function phCreateSphere%()
	phEnt.phEntity = New phEntity
	radius#=6
	phEnt\mesh=CreateSphere()
	EntityShininess phEnt\mesh,0.5
	ScaleEntity phEnt\mesh,radius,radius,radius
	phEnt\body=btBodyCreateSphere(radius,Rnd(5,10))
	EntityColor phEnt\mesh,Rand(100,150),Rand(100,150),Rand(100,150)		
	btBodySetPosition(phEnt\body,Rnd(-250,250),Rnd(50,290),Rnd(-250,250))
	btBodySetRotation(phEnt\body,Rnd(-180,180),Rnd(-180,180),Rnd(-180,180))
	btBodyAttachEntity(phEnt\body,phEnt\mesh)
	btBodySetFriction(phEnt\body,0.02)
	btBodySetLinearDamping(phEnt\body,0.2)
	
	btBodySetAngularSleepingThreshold(phEnt\body,0.6)
	btBodySetLinearSleepingThreshold(phEnt\body,0.6)
	
	Return phEnt\body
End Function

Function phCreateCube%(r%, g%, b%)
	phEnt.phEntity = New phEntity
	phEnt\mesh=CreateCube()
	dx#=4
	dy#=4
	dz#=4
	ScaleEntity phEnt\mesh,dx,dy,dz
	phEnt\body=btBodyCreateBox(dx,dy,dz,Rnd(10,20))
	EntityColor phEnt\mesh,r,g,b		
	btBodySetPosition(phEnt\body,Rnd(-250,250),Rnd(50,290),Rnd(-250,250))
	btBodySetRotation(phEnt\body,Rnd(-180,180),Rnd(-180,180),Rnd(-180,180))
	btBodyAttachEntity(phEnt\body,phEnt\mesh)
	btBodySetFriction(phEnt\body,0.02)
	btBodySetLinearDamping(phEnt\body,0.2)
	
	btBodySetAngularSleepingThreshold(phEnt\body,0.08)
	btBodySetLinearSleepingThreshold(phEnt\body,0.06)
	
	Return phEnt\body
End Function

Function phResetAllEntity()

	For phEnt.phEntity = Each phEntity
		btBodySetSleep(phEnt\body,0)
		btBodySetAngularVelocity(phEnt\body,0,0,0)
		btBodySetLinearVelocity(phEnt\body,0,0,0)
		btBodySetRotation(phEnt\body,0,0,0)
	Next
	
End Function

