;*******************************************************************
;*******************************************************************
;***                                        
;***	Example of use BlitzBullet 
;***	(Physics Bullet Library wrapper for Blitz3D) 
;***   
;***	(c) 2010-2011 Mirage-lab Team 
;***	www.tools.mirage-lab.com                       
;***                                                  
;*******************************************************************
;*******************************************************************

Include "..\include\BlitzBullet.bb"

Graphics3D 800, 600,32,2
AppTitle "BlitzBullet: Maze"
SetBuffer(BackBuffer())
SetFont LoadFont("Blitz")
SeedRnd MilliSecs ()

btCreateWorld(0,"license_key")
btCreateDebugDraw()
btDebugDrawSetMode(0)
btWorldSetFixedTimeStep(1.0/60)

camera=CreateCamera()
AmbientLight 180,180,180
PositionEntity camera,0,100,-80
RotateEntity camera,35,0,0

AmbientLight 100,100,100
light=CreateLight()
RotateEntity light,25,0,20

plane=CreatePlane()
texPlane=LoadTexture( "..\media\cell.png" )
ScaleTexture texPlane,40,40
EntityTexture plane,texPlane,0,1 


meshMaze=CreateCube()
EntityColor meshMaze,150,100,70
ScaleEntity meshMaze,50,1,50

shapeMaze=btShapeCreateCompound()
bodyMain=btBodyCreateBox(50,1,50,0)
btShapeCompoundAddBody(shapeMaze,bodyMain,0,1)

meshMazeWallUp=CreateCube(meshMaze)
EntityColor meshMazeWallUp,150,100,70
ScaleEntity meshMazeWallUp,49.5,5,1,1
PositionEntity meshMazeWallUp,0,4,49,1
bodyMazeWallUp=btBodyCreateBox(49.5,5,1,0)
btBodySetPosition (bodyMazeWallUp,0,4,49)
btShapeCompoundAddBody(shapeMaze,bodyMazeWallUp,0,1)

meshMazeWallDown=CreateCube(meshMaze)
EntityColor meshMazeWallDown,150,100,70
ScaleEntity meshMazeWallDown,50,5,1,1
PositionEntity meshMazeWallDown,0,4,-49,1
bodyMazeWallDown=btBodyCreateBox(50,5,1,0)
btBodySetPosition (bodyMazeWallDown,0,4,-49)
btShapeCompoundAddBody(shapeMaze,bodyMazeWallDown,0,1)

meshMazeWallLeft=CreateCube(meshMaze)
EntityColor meshMazeWallLeft,150,100,70
ScaleEntity meshMazeWallLeft,1,5,50,1
PositionEntity meshMazeWallLeft,-49,4,0,1
bodyMazeWallLeft=btBodyCreateBox(1,5,50,0)
btBodySetPosition (bodyMazeWallLeft,-49,4,0)
btShapeCompoundAddBody(shapeMaze,bodyMazeWallLeft,0,1)

meshMazeWallRight=CreateCube(meshMaze)
EntityColor meshMazeWallRight,150,100,70
ScaleEntity meshMazeWallRight,1,5,40,1
PositionEntity meshMazeWallRight,49,4,10,1
bodyMazeWallRight=btBodyCreateBox(1,5,40,0)
btBodySetPosition (bodyMazeWallRight,49,4,10)
btShapeCompoundAddBody(shapeMaze,bodyMazeWallRight,0,1)

meshMazeWall_1=CreateCube(meshMaze)
EntityColor meshMazeWall_1,150,120,70
ScaleEntity meshMazeWall_1,1,4,40,1
PositionEntity meshMazeWall_1,-30,4,10,1
bodyMazeWall_1=btBodyCreateBox(1,4,40,0)
btBodySetPosition (bodyMazeWall_1,-30,4,10)
btShapeCompoundAddBody(shapeMaze,bodyMazeWall_1,0,1)

meshMazeWall_2=CreateCube(meshMaze)
EntityColor meshMazeWall_2,150,120,70
ScaleEntity meshMazeWall_2,1,4,39.5,1
PositionEntity meshMazeWall_2,-10,4,-10,1
bodyMazeWall_2=btBodyCreateBox(1,4,40,0)
btBodySetPosition (bodyMazeWall_2,-10,4,-10)
btShapeCompoundAddBody(shapeMaze,bodyMazeWall_2,0,1)

meshMazeWall_3=CreateCube(meshMaze)
EntityColor meshMazeWall_3,150,120,70
ScaleEntity meshMazeWall_3,20,4,1,1
PositionEntity meshMazeWall_3,9,4,30,1
bodyMazeWall_3=btBodyCreateBox(20,4,1,0)
btBodySetPosition (bodyMazeWall_3,9,4,30)
btShapeCompoundAddBody(shapeMaze,bodyMazeWall_3,0,1)

meshMazeWall_4=CreateCube(meshMaze)
EntityColor meshMazeWall_4,150,120,70
ScaleEntity meshMazeWall_4,20,4,1,1
PositionEntity meshMazeWall_4,30,4,10,1
bodyMazeWall_4=btBodyCreateBox(20,4,1,0)
btBodySetPosition (bodyMazeWall_4,30,4,10)
btShapeCompoundAddBody(shapeMaze,bodyMazeWall_4,0,1)

meshMazeWall_5=CreateCube(meshMaze)
EntityColor meshMazeWall_5,150,120,70
ScaleEntity meshMazeWall_5,20,4,1,1
PositionEntity meshMazeWall_5,10,4,-10,1
bodyMazeWall_5=btBodyCreateBox(20,4,1,0)
btBodySetPosition (bodyMazeWall_5,10,4,-10)
btShapeCompoundAddBody(shapeMaze,bodyMazeWall_5,0,1)

meshMazeWall_6=CreateCube(meshMaze)
EntityColor meshMazeWall_6,150,120,70
ScaleEntity meshMazeWall_6,20,4,1,1
PositionEntity meshMazeWall_6,30,4,-28.9,1
bodyMazeWall_6=btBodyCreateBox(20,4,1,0)
btBodySetPosition (bodyMazeWall_6,30,4,-28.9)
btShapeCompoundAddBody(shapeMaze,bodyMazeWall_6,0,1)

bodyMaze=btBodyCreateCompound(shapeMaze,500)
btBodySetFriction(bodyMaze,0.1)
btBodyAttachEntity(bodyMaze,meshMaze)
btBodySetPosition(bodyMaze,0,20,0)
btBodySetLinearFactorX(bodyMaze,0)
btBodySetLinearFactorY(bodyMaze,0)
btBodySetLinearFactorZ(bodyMaze,0)
btBodySetAngularFactorX(bodyMaze,0)
btBodySetAngularFactorY(bodyMaze,0)
btBodySetAngularFactorZ(bodyMaze,0)


meshSphere=CreateSphere()
EntityColor meshSphere,100,220,100
ScaleEntity meshSphere,5,5,5
bodySphere=btBodyCreateSphere(5,1)
btBodyAttachEntity(bodySphere,meshSphere)
btBodySetPosition(bodySphere,-40,50,40)
btBodySetFriction(bodySphere,0.2)



Repeat	
	If KeyHit(2) btDebugDrawSetMode(0)
	If KeyHit(3) btDebugDrawSetMode(1)
	If KeyHit(4) btDebugDrawSetMode(2)
	If KeyHit(5) btDebugDrawSetMode(1+2)

	If KeyDown(203) And btBodyGetRoll(bodyMaze)<10 Then
		btBodySetAngularFactorZ(bodyMaze,1)
		btBodyApplyTorqueImpulse(bodyMaze,0,0,2000)
	Else
		If KeyDown(205) And btBodyGetRoll(bodyMaze)>-10  Then
			btBodySetAngularFactorZ(bodyMaze,1)
			btBodyApplyTorqueImpulse(bodyMaze,0,0,-2000)
		Else
			btBodySetAngularVelocity(bodyMaze,btBodyGetAngularVelocityX(bodyMaze),0,0)
			btBodySetAngularFactorZ(bodyMaze,0)
		EndIf
	EndIf

	If KeyDown(200) And btBodyGetPitch(bodyMaze)<10  Then
		btBodySetAngularFactorX(bodyMaze,1)
		btBodyApplyTorqueImpulse(bodyMaze,2000,0,0)
	Else
		If KeyDown(208) And btBodyGetPitch(bodyMaze)>-10 Then
			btBodySetAngularFactorX(bodyMaze,1)
			btBodyApplyTorqueImpulse(bodyMaze,-2000,0,0)
		Else
			btBodySetAngularVelocity(bodyMaze,0,0,btBodyGetAngularVelocityZ(bodyMaze))
			btBodySetAngularFactorX(bodyMaze,0)
		EndIf
	EndIf

	If KeyHit(57)
		btBodySetSleep(bodySphere,0)
		btBodySetAngularVelocity(bodySphere,0,0,0)
		btBodySetLinearVelocity(bodySphere,0,0,0)
		btBodySetPosition(bodySphere,-40,50,40)
		btBodySetRotation(bodyMaze,0,0,0)
	EndIf

	btBodySetRotation(bodyMaze,btBodyGetPitch(bodyMaze),0,btBodyGetRoll(bodyMaze))
	PositionEntity meshMaze,btBodyGetX(bodyMaze),btBodyGetY(bodyMaze),btBodyGetZ(bodyMaze)
	RotateEntity meshMaze,btBodyGetPitch(bodyMaze),btBodyGetYaw(bodyMaze),btBodyGetRoll(bodyMaze)
		
	btSimulation(.2,6)

	UpdateWorld()
	RenderWorld()
	btDebugDrawWorld(camera)

	frames=frames+1
   	If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 	Text 10,10,"FPS: "+fps1
	Text 10,30,"1,2,3,4 - debug draw mode"
	Text 10,50,"Arrows - control slope of the maze"
	Text 10,70,"Space - reset scene"

	Flip 1
	
Until KeyHit(1)

btDestroyWorld()
End