;*******************************************************************
;*******************************************************************
;***                                        
;***	Example of use BlitzBullet 
;***	(Physics Bullet Library wrapper for Blitz3D) 
;***   
;***	(c) 2010-2011 Mirage-lab Team 
;***	www.tools.mirage-lab.com                       
;***                                                  
;*******************************************************************
;*******************************************************************

Include "..\include\BlitzBullet.bb"

Graphics3D 800, 600,32,2
AppTitle "BlitzBullet: Grab a prize"
SetBuffer(BackBuffer())
SetFont LoadFont("Blitz")
SeedRnd MilliSecs()

btCreateWorld(0,"license_key")
btCreateDebugDraw()
btDebugDrawSetMode(DBG_WF+DBG_JOINTLIMITS+DBG_RAYS+DBG_RAYCASTPOINTS)
btDebugDrawSetSizePointRays(3)
btWorldSetFixedTimeStep(1.0/30)
btContactSetSolverMode(SOLVER_SIMD+SOLVER_RANDMIZE_ORDER)

Global camera=CreateCamera()
AmbientLight 180,180,180
PositionEntity camera,0,150,-200
RotateEntity camera,30,0,0
CameraClsColor camera,70,70,70

AmbientLight 150,150,150
light=CreateLight()
PositionEntity light,0,400,0
RotateEntity light,10,0,0

Global meshPlane=CreatePlane()
tex=LoadTexture("..\media\cell.png")
ScaleTexture tex,40,40
EntityTexture meshPlane,tex,0,1 

bodyPlane=btBodyCreatePlane(0,1,0)

For i=0 To 10
	phCreateSphere()
	phCreateCube()
Next

box1=btBodyCreateBox(3,3,3,200)
btBodySetPosition box1,0,120,0
btBodyEnableCollision(box1,0)

box2=btBodyCreateBox(6,6,6,50)
btBodySetPosition box2,0,120,0
btBodyEnableCollision(box2,0)

box3=btBodyCreateBox(3,3,3,50)
btBodySetPosition box3,0,100,0
btBodyEnableCollision(box3,0)

jointSlider1=btJointCreateSlider(box1, box2, 0,0,0,0, 0,0,0,0, 0)
btJointSliderSetLinearLimit(jointSlider1,-140,140)

jointSlider2=btJointCreateSlider( box1,0, 0,0,0,0, 0,0,0,0, 0)
btJointSliderSetLinearLimit(jointSlider2,-140,140)

btJointSetRotationA(jointSlider2,0,90,0)
btJointSetRotationA(jointSlider1,0,90,0)

btJointSliderSetSoftnessOrtho(jointSlider1,5,5)
btJointSliderSetSoftnessOrtho(jointSlider2,5,5)
btJointSliderSetSoftnessLimit(jointSlider1,10,10)
btJointSliderSetSoftnessLimit(jointSlider2,10,10)


BodyClawMain=phCreateClawMain()
jointPoint2Point=btJointCreatePoint2Point( box2, box3, 0,0,0,0, 0,15,0,0, 0)
jointRotateClaw=btJointCreateHinge( box3, BodyClawMain, 0,0,0,0, 0,0,0,0, 1)
btJointHingeSetAxis(jointRotateClaw,0,1,0)
btJointHingeSetMaxMotorImpulse(jointRotateClaw,200)

BodyClawPart1_1=phCreateClawUpperElement()
btBodySetPosition(BodyClawPart1_1,10,100,0)
BodyClawPart1_2=phCreateClawLowerElement()
btBodySetPosition(BodyClawPart1_2,10,90,0)

jointHingePart1_1=btJointCreateHinge( BodyClawPart1_1,BodyClawMain, 0,14,0,0, 15,-5,0,0, 1)
jointHingePart1_2=btJointCreateHinge( BodyClawPart1_2,BodyClawPart1_1, 0,7,0,0, 0,-10,0,0, 1)

btJointHingeSetLimit(jointHingePart1_2,-140,40)
btJointHingeSetMaxMotorImpulse(jointHingePart1_2,190)
btJointHingeEnableMotor(jointHingePart1_2,1)

btJointHingeSetLimit(jointHingePart1_1,-120,5)
btJointHingeSetMaxMotorImpulse(jointHingePart1_1,190)
btJointHingeEnableMotor(jointHingePart1_1,1)


BodyClawPart2_1=phCreateClawUpperElement()
btBodySetPosition(BodyClawPart2_1,-10,100,0)
BodyClawPart2_2=phCreateClawLowerElement()
btBodySetPosition(BodyClawPart2_2,-10,90,0)

jointHingePart2_1=btJointCreateHinge( BodyClawPart2_1,BodyClawMain, 0,14,0,0, -15,-5,0,0, 1)
jointHingePart2_2=btJointCreateHinge( BodyClawPart2_2,BodyClawPart2_1, 0,7,0,0, 0,-10,0,0, 1)

btJointHingeSetLimit(jointHingePart2_2,-140,40)
btJointHingeSetAxis(jointHingePart2_2,0,0,-1)
btJointHingeSetMaxMotorImpulse(jointHingePart2_2,190)
btJointHingeEnableMotor(jointHingePart2_2,1)

btJointHingeSetLimit(jointHingePart2_1,-120,5)
btJointHingeSetAxis(jointHingePart2_1,0,0,-1)
btJointHingeSetMaxMotorImpulse(jointHingePart2_1,190)
btJointHingeEnableMotor(jointHingePart2_1,1)

targetAngle#=100

btJointHingeSetMotorTarget(jointHingePart1_2,targetAngle,100)
btJointHingeSetMotorTarget(jointHingePart1_1,targetAngle,-100)
btJointHingeSetMotorTarget(jointHingePart2_2,targetAngle,100)
btJointHingeSetMotorTarget(jointHingePart2_1,targetAngle,-100)

ray=btCreateRay()
btRaySetMaxDistance(ray,200)
btRaySetMethodPick(ray,2)

clawState=1
Global hide=0
Const UPS=60
jointPos#=15

Repeat
	
	If KeyHit(2) btDebugDrawSetMode(0)
	If KeyHit(3) btDebugDrawSetMode(DBG_WF+DBG_JOINTLIMITS+DBG_JOINTS+DBG_RAYS+DBG_RAYCASTPOINTS)
	If KeyHit(4) btDebugDrawSetMode(DBG_AABB+DBG_JOINTLIMITS+DBG_RAYS+DBG_RAYCASTPOINTS)
	If KeyHit(5) btDebugDrawSetMode(DBG_WF+DBG_AABB+DBG_JOINTLIMITS+DBG_RAYS+DBG_RAYCASTPOINTS)

	If KeyHit(35) Then HideShowMeshes()

	If KeyDown(200) Then btBodyApplyForce(box1,0,0,450)
	If KeyDown(208) Then btBodyApplyForce(box1,0,0,-450)

	If KeyDown(203) Then btBodyApplyForce(box2,-250,0,0)
	If KeyDown(205) Then btBodyApplyForce(box2,250,0,0)
	
			
	If KeyDown(16) Then
		;If clawState=0
			btJointHingeSetMotorTarget(jointHingePart1_2,targetAngle,100)
			btJointHingeSetMotorTarget(jointHingePart1_1,targetAngle,-100)
			btJointHingeSetMotorTarget(jointHingePart2_2,targetAngle,100)
			btJointHingeSetMotorTarget(jointHingePart2_1,targetAngle,-100)

			btBodySetSleep(BodyClawPart1_1,1)
			btBodySetSleep(BodyClawPart1_2,1)
			btBodySetSleep(BodyClawPart2_1,1)
			btBodySetSleep(BodyClawPart2_2,1)
			clawState=1
		;EndIf
	EndIf

	If KeyDown(18) Then
		;If clawState=1
			btJointHingeSetMotorTarget(jointHingePart1_2,targetAngle,100)
			btJointHingeSetMotorTarget(jointHingePart1_1,targetAngle,100)	
			btJointHingeSetMotorTarget(jointHingePart2_2,targetAngle,100)
			btJointHingeSetMotorTarget(jointHingePart2_1,targetAngle,100)
	
			btBodySetSleep(BodyClawPart1_1,1)
			btBodySetSleep(BodyClawPart1_2,1)
			btBodySetSleep(BodyClawPart2_1,1)
			btBodySetSleep(BodyClawPart2_2,1)
			clawState=0
		;EndIf
	EndIf

	If KeyDown(30) Then
		btJointHingeSetMotorTarget(jointRotateClaw,80,1)
		btJointHingeEnableMotor(jointRotateClaw,1)
	Else
		If KeyDown(32) Then
			btJointHingeSetMotorTarget(jointRotateClaw,-80,1)
			btJointHingeEnableMotor(jointRotateClaw,1)
		Else
			btJointHingeEnableMotor(jointRotateClaw,0)
		EndIf
	EndIf
	

	If KeyDown(17)
		btBodySetSleep(BodyClawMain,1)
		If jointPos>15 Then
			jointPos=jointPos-0.4
		EndIf
		btJointSetPositionB(jointPoint2Point,0,jointPos,0)	
	EndIf
	If KeyDown(31)
		btBodySetSleep(BodyClawMain,1)
		If jointPos<77 Then
			jointPos=jointPos+0.4
		EndIf
		btJointSetPositionB(jointPoint2Point,0,jointPos,0)	
	EndIf
	
	btRaySetPosition(ray,btBodyGetX(BodyClawMain),btBodyGetY(BodyClawMain),btBodyGetZ(BodyClawMain))
	btRaySetDirection(ray,-btBodyGetUpX(BodyClawMain),-btBodyGetUpY(BodyClawMain),-btBodyGetUpZ(BodyClawMain))
	

	btSimulation(0.09,6)
	
	UpdateWorld()
	RenderWorld()
	btDebugDrawWorld(camera)
	Frames=Frames+1  
   	If MilliSecs()-render_time=>1000  fps1=Frames : Frames=0 : render_time=MilliSecs()
	Text 10,10,"FPS: "+fps1
	Text 10,30,"1,2,3,4 - debug draw mode"
	Text 10,50,"H - hide/show meshes"
	Text 10,70,"E - grab"
	Text 10,90,"Q - release"
	Text 10,110,"W / S - to upper/lower a claw"
	Text 10,130,"A / D - rotate a claw"
	Text 10,150,"Arrows - movement a claw"

	Flip 1
	
Until KeyHit(1)

btDestroyWorld()

End

Type phEntity
	Field mesh
	Field body
End Type

Function phCreateClawMain()
	phEnt.phEntity = New phEntity
	phEnt\mesh=CreateCube()
	EntityColor phEnt\mesh,70,70,150
	ScaleEntity phEnt\mesh,6,8,6
	phEnt\body=btBodyCreateBox(6,8,6,10)
	btBodyAttachEntity(phEnt\body,phEnt\mesh)
	btBodySetPosition(phEnt\body,0,120,0)
	Return phEnt\body
End Function

Function phCreateClawUpperElement()
	phEnt.phEntity = New phEntity
	phEnt\mesh=CreateCube()
	EntityColor phEnt\mesh,150,70,70
	ScaleEntity phEnt\mesh,2.5,10,7
	phEnt\body=btBodyCreateBox(2.5,10,7,10)
	btBodyAttachEntity(phEnt\body,phEnt\mesh)
	Return phEnt\body
End Function

Function phCreateClawLowerElement()
	phEnt.phEntity = New phEntity
	phEnt\mesh=CreateCube()
	EntityColor phEnt\mesh,70,150,70
	ScaleEntity phEnt\mesh,2,7,6
	phEnt\body=btBodyCreateBox(2,7,6,10)
	btBodyAttachEntity(phEnt\body,phEnt\mesh)
	;btBodySetFriction(phEnt\body,0.8)
	Return phEnt\body
End Function

Function phCreateSphere()
	phEnt.phEntity = New phEntity
	radius#=Rnd(10,15)
	phEnt\mesh=CreateSphere()
	EntityShininess phEnt\mesh,0.5
	ScaleEntity phEnt\mesh,radius,radius,radius
	phEnt\body=btBodyCreateSphere(radius,Rnd(2,4))
	EntityColor phEnt\mesh,Rand(100,160),Rand(100,160),Rand(100,160)		
	btBodySetPosition(phEnt\body,Rnd(-200,200),Rnd(50,290),Rnd(-200,200))
	btBodySetRotation(phEnt\body,Rnd(-180,180),Rnd(-180,180),Rnd(-180,180))
	btBodyAttachEntity(phEnt\body,phEnt\mesh)
	btBodySetFriction(phEnt\body,0.4)
	btBodySetLinearDamping(phEnt\body,0.1)
	
	btBodySetAngularSleepingThreshold(phEnt\body,0.6)
	btBodySetLinearSleepingThreshold(phEnt\body,0.6)
End Function

Function phCreateCube()
	phEnt.phEntity = New phEntity
	phEnt\mesh=CreateCube()
	EntityShininess phEnt\mesh,0.5
	dx#=Rnd(8,14)
	dy#=Rnd(8,14)
	dz#=Rnd(8,14)
	ScaleEntity phEnt\mesh,dx,dy,dz
	phEnt\body=btBodyCreateBox(dx,dy,dz,Rnd(2,4))
	EntityColor phEnt\mesh,Rand(100,160),Rand(100,160),Rand(100,160)		
	btBodySetPosition(phEnt\body,Rnd(-200,200),Rnd(50,290),Rnd(-200,200))
	btBodySetRotation(phEnt\body,Rnd(-180,180),Rnd(-180,180),Rnd(-180,180))
	btBodyAttachEntity(phEnt\body,phEnt\mesh)
	btBodySetFriction(phEnt\body,0.4)
	btBodySetLinearDamping(phEnt\body,0.1)
	
	btBodySetAngularSleepingThreshold(phEnt\body,0.8)
	btBodySetLinearSleepingThreshold(phEnt\body,0.4)
End Function

Function Camera_Look(cam,speedx#=.5,speedy#=.5,dang=-89,upang=89)
	If KeyDown(17) Then 
		MoveEntity cam,0,0,1
	Else
		If KeyDown(31) Then MoveEntity cam,0,0,-1
	EndIf
	If KeyDown(30) Then 
		MoveEntity cam,-1,0,0	
	Else
		If KeyDown(32) Then MoveEntity cam,1,0,0
	EndIf	
	
	xrot#=EntityPitch(cam)
	yrot#=EntityYaw(cam)
	If(xrot#<upang)And(msy>0)Then xrot#=xrot#+speedx#*msy/10  
	If(xrot#>upang)And(msy>0)Then xrot#=upang	
	If(xrot#>dang)And(msy<0)Then xrot#=xrot#+speedx#*msy/10 
	If(xrot#<dang)And(msy<0)Then xrot#=dang		
	yrot=yrot-speedy#*msx/10 
	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
	RotateEntity cam,xrot,yrot,0
End Function

Function HideShowMeshes()

	If hide=0 Then
		For phEnt.phEntity = Each phEntity
			HideEntity phEnt\mesh
			HideEntity meshPlane
		Next
		hide=1
	Else
		For phEnt.phEntity = Each phEntity
			ShowEntity phEnt\mesh
			ShowEntity meshPlane
		Next
		hide=0
	EndIf
	
End Function
