;*******************************************************************
;*******************************************************************
;***                                        
;***	Example of use BlitzBullet 
;***	(Physics Bullet Library wrapper for Blitz3D) 
;***   
;***	(c) 2010-2011 Mirage-lab Team 
;***	www.tools.mirage-lab.com                       
;***                                                  
;*******************************************************************
;*******************************************************************

Include "..\include\BlitzBullet.bb"

Graphics3D 800, 600,32,2
AppTitle "BlitzBullet: Center Of Mass"
SetBuffer(BackBuffer())
SetFont LoadFont("Blitz")
SeedRnd MilliSecs ()

btCreateWorld(0,"license_key")
btCreateDebugDraw()
btDebugDrawSetMode(1)
btWorldSetFixedTimeStep(1.0/30)
btContactSetSolverMode(SOLVER_USE_2_FRICTION_DIRECTIONS+SOLVER_SIMD+SOLVER_RANDMIZE_ORDER)

camera=CreateCamera()
AmbientLight 180,180,180
PositionEntity camera,0,50,-50
RotateEntity camera,20,0,0
CameraClsColor camera,70,70,70

AmbientLight 90,90,90
light=CreateLight()
RotateEntity light,25,0,20

Global meshPlane=CreatePlane()
texPlane=LoadTexture( "..\media\cell.png" )
ScaleTexture texPlane,40,40
EntityTexture meshPlane,texPlane,0,1 

bodyPlane=btBodyCreatePlane(0,1,0)

bodyCompound=btBodyCreateCompound(btShapeCreateCompound(),5)
btBodySetFriction(bodyCompound,1)
btBodySetAngularSleepingThreshold(bodyCompound,0.01)
btBodySetAngularDamping(bodyCompound,0.5)

bodyBox=btBodyCreateBox(25,6,6,50)
btBodyCompoundAddBody(bodyCompound,bodyBox,1,0,1)
btBodySetPosition(bodyCompound,0,35,0)
btBodySetRotation(bodyCompound,0,0,0)

meshBox=CreateCube()
EntityColor meshBox,150,0,0
EntityAlpha meshBox,0.25
ScaleEntity meshBox,25,6,6
btBodyAttachEntity(bodyCompound,meshBox)

meshBox=CreateCube()
EntityColor meshBox,0,0,150
ScaleEntity meshBox,5,6,6
bodyBox=btBodyCreateBox(5,6,6,0)
btBodySetFriction(bodyBox,1)
btBodyAttachEntity(bodyBox,meshBox)
btBodySetPosition(bodyBox,0,20,0)

Global mx#,my#,msx#,msy#
Repeat	
	If KeyHit(2) btDebugDrawSetMode(0)
	If KeyHit(3) btDebugDrawSetMode(1)
	If KeyHit(4) btDebugDrawSetMode(2)
	If KeyHit(5) btDebugDrawSetMode(1+2)

	repos#=repos+1.6
	btBodySetCenterOfMass(bodyCompound,Sin(repos)*5.7,0,0) ;<< only for compound bodies

	btSimulation(.06,6)

	UpdateWorld()
	RenderWorld()
	btDebugDrawWorld(camera)

	frames=frames+1
   	If MilliSecs()-render_time=>1000  fps1=frames : frames=0 : render_time=MilliSecs()  
 	Text 10,10,"FPS: "+fps1
	Text 10,30,"1,2,3,4 - debug draw mode"
	
	Flip 1
	
Until KeyHit(1)

btDestroyWorld()
End
